tempo equ 160

dseg
SoundProc_: public SoundProc_
    defw 0

Ch.Ptr defw 0
Ch.Len defb 0
Ch.Vol defb 0
time: defw 0
wait defb 0

cseg

InitSound_: public InitSound_
    push af | push hl
        ld hl,0
        ld (SoundProc_),hl
        ld (time),hl
        xor a
        ld (Ch.Ptr),a
        ld (Ch.Ptr+1),a
        ld hl,0
    pop hl | pop af
ret


CallSound:
jp (hl)

CallSound_: public CallSound_
    push af | push hl
    ld hl,(SoundProc_)
    ld a,l
    or h
    if nz
        call CallSound
        ld hl,0
        ld (SoundProc_),hl
    endif
    pop hl | pop af
ret


ToneOn:
; in
;   hl : cycle
    push af
        ld a,36h
        ld (0e007h),a
        ld a,l
        ld (0e004h),a
        ld a,h
        ld (0e004h),a
        ld a,1
        ld (0e008h),a
    pop af
ret

Tonewait: public Tonewait
; in
;   a: length
    ld (wait),a
    do
        ld a,(wait)
        or a
    while nz | wend
ret

ToneOff:
    xor a
    ld (0e008h),a
ret


Sound_Beep_: public Sound_Beep_
    push af | push hl
        ld hl, 2033
        call ToneOn
        ld a,5
        call Tonewait
        call ToneOff
    pop hl | pop af
ret 


Sound_Loose:
    push af | push hl
        ld hl,2033*2
        call ToneOn
        ld a,5
        call Tonewait
        call ToneOff
    pop hl | pop af
ret 

Sound_Loose_:  public Sound_Loose_
    push hl
        ld hl,Sound_Loose
        ld (SoundProc_),hl
    pop hl
ret


SoundHandler: public SoundHandler
    ld a,(Wait)
    or a
    if nz
        dec a
        ld (Wait),a
    endif

    push hl | push de
        ld hl,(time)
        ld de,-tempo
        add hl,de
        if nc
            push hl
                ld hl,(Ch.Ptr)
                ld a,l
                or h
                if nz
                    ld a,(Ch.Len)
                    dec a
                    ld (Ch.Len),a
                    if z
                        ld a,(hl)
                        or a
                        if z
                            ; end
                            ld hl,0
                            ld (Ch.Ptr),hl
                            call ToneOff
                            jr next
                        else
                            ld (Ch.Len),a
                            inc hl
                            ld a,(hl)
                            inc hl
                            ld (Ch.Ptr),hl
                            or a
                            if nz
                                dec a
                                add a,a
                                ld e,a
                                ld d,0
                                ld hl,cycles
                                add hl,de
                                ld a,(hl)
                                inc hl
                                ld h,(hl)
                                ld l,a
                                call ToneOn
                            else
                                call ToneOff
                            endif
                        endif
                    endif
                endif
                next:
            pop hl
            ld de,600/2
            add hl,de
        endif
        ld (time),hl
    pop de | pop hl
ret

MelodyWait:
    di
    ld (Ch.Ptr),hl
    ld a,1
    ld (Ch.Len),a
    ei
    do
        ld hl,(Ch.Ptr)
        ld a,l
        or h
    while nz | wend
ret 


item_notes:
    defb 1,C4, 1, C4S, 1,D4, 1,F4, 1,A4, 1,C5, 0
Sound_Item:
    ld hl,item_notes
    call MelodyWait
ret

Sound_Item_:  public Sound_Item_
    push hl
        ld hl,Sound_Item
        ld (SoundProc_),hl
    pop hl
ret


start_notes: 
	defb 6,0, 5,C5,1,0, 5,C5,1,0, 5,C5,1,0
	defb 5,C5,1,0, 11,G4,1,0, 11,C5,1,0
	defb 5,C5,1,0, 5,D5,1,0, 5,C5,1,0, 11,D5,1,0
	defb 11,E5,1,0, 47,C5,1,0
    defb 0
Sound_Start_:
    public Sound_Start_
    push hl
        ld hl,start_notes
        call MelodyWait
    pop hl
ret

clear_notes: 
	defb 5,C4,1,0, 5,E4,1,0, 5,G4,1,0, 5,D4,1,0
	defb 5,F4,1,0, 5,A4,1,0, 5,E4,1,0, 5,G4,1,0
	defb 5,B4,1,0, 17,C5,1,0
    defb 0
Sound_Clear_:
    public Sound_Clear_
    push hl
        ld hl,clear_notes
        call MelodyWait
    pop hl
ret

over_notes: 
	defb 5,C5,1,0, 5,C5,1,0, 5,G4,1,0, 5,G4,1,0
	defb 5,A4,1,0, 5,A4,1,0, 5,B4,1,0, 5,B4,1,0
	defb 30,C5,18,0
    defb 0
Sound_GameOver_:
    public Sound_GameOver_
    push hl
        ld hl,over_notes
        call MelodyWait
    pop hl
ret


C4 equ 1
C4S equ 2
D4 equ 3
D4S equ 4
E4 equ 5
F4 equ 6
FS equ 7
G4 equ 8
G4S equ 9
A4 equ 10
A4S equ 11
B4 equ 12
C5 equ 13
C5S equ 14
D5 equ 15
D5S equ 16
E5 equ 17

cycles:
defw 3420 ; C4
defw 3228 ; C#4
defw 3047 ; D4
defw 2876 ; D#4
defw 2714 ; E4
defw 2562 ; F4
defw 2418 ; F#4
defw 2282 ; G4
defw 2154 ; G#4
defw 2033 ; A4
defw 1919 ; A#4
defw 1811 ; B4
defw 1710 ; C5
defw 1614 ; C#5
defw 1523 ; D5
defw 1438 ; D#5
defw 1357 ; E5
